Package net.sf.saxon.expr

## Interface XPathContext

- All Known Implementing Classes:
    `EarlyEvaluationContext`, `XPathContextMajor`, `XPathContextMinor`

      public interface XPathContext

  This class represents a context in which an XPath expression is evaluated.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Sequence` | `evaluateLocalVariable​(int slotnumber)` | Get the value of a local variable, identified by its slot number
    `XPathContext` | `getCaller()` | Get the calling XPathContext (the next one down the stack).
    `Configuration` | `getConfiguration()` | Get the Configuration
    `Item` | `getContextItem()` | Get the context item
    `Controller` | `getController()` | Get the Controller.
    `Component` | `getCurrentComponent()` | Get the current component
    `DateTimeValue` | `getCurrentDateTime()` | Get the current date and time
    `XPathException` | `getCurrentException()` | Get the current exception (in saxon:catch)
    `GroupIterator` | `getCurrentGroupIterator()` | Get the current group iterator.
    `FocusIterator` | `getCurrentIterator()` | Get the current iterator.
    `GroupIterator` | `getCurrentMergeGroupIterator()` | Get the current merge group iterator.
    `Component.M` | `getCurrentMode()` | Get the current mode.
    `java.lang.String` | `getCurrentOutputUri()` | Get the current output URI
    `RegexIterator` | `getCurrentRegexIterator()` | Get the current regex iterator.
    `Rule` | `getCurrentTemplateRule()` | Get the current template rule.
    `ErrorReporter` | `getErrorReporter()` | Get the error reporter.
    `int` | `getImplicitTimezone()` | Get the implicit timezone
    `int` | `getLast()` | Get the context size (the position of the last item in the current node list)
    `ParameterSet` | `getLocalParameters()` | Get the local (non-tunnel) parameters that were passed to the current function or template
    `NamePool` | `getNamePool()` | Get the Name Pool
    `StackFrame` | `getStackFrame()` | Get a reference to the local stack frame for variables.
    `Component` | `getTargetComponent​(int bindingSlot)` | Bind a component reference to a component.
    `int` | `getTemporaryOutputState()` | Ask whether the XSLT output state is "temporary" or "final"
    `XPathContextMajor.ThreadManager` | `getThreadManager()` | Get the thread manager used to process asynchronous xsl:result-document threads.
    `ParameterSet` | `getTunnelParameters()` | Get the tunnel parameters that were passed to the current function or template.
    `javax.xml.transform.URIResolver` | `getURIResolver()` | Get the URI resolver.
    `boolean` | `isAtLast()` | Determine whether the context position is the same as the context size that is, whether position()=last().
    `java.util.Iterator` | `iterateStackFrames()` | Get the context stack.
    `XPathContextMajor` | `newCleanContext()` | Construct a new context without copying (used for the context in a function call)
    `XPathContextMajor` | `newContext()` | Construct a new context as a copy of another.
    `XPathContextMinor` | `newMinorContext()` | Construct a new minor context.
    `void` | `setCaller​(XPathContext caller)` | Set the calling XPathContext
    `void` | `setCurrentIterator​(FocusIterator iter)` | Set a new sequence iterator.
    `void` | `setCurrentOutputUri​(java.lang.String uri)` | Set the current output URI
    `void` | `setLocalVariable​(int slotNumber, Sequence value)` | Set the value of a local variable, identified by its slot number
    `void` | `setTemporaryOutputState​(int temporary)` | Set the XSLT output state to "temporary" or "final"
    `FocusIterator` | `trackFocus​(SequenceIterator iter)` | Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator.
    `int` | `useLocalParameter​(StructuredQName parameterId, int slotNumber, boolean isTunnel)` | Use local parameter.
    `void` | `waitForChildThreads()` | Wait for child threads started under the control of this context to finish.

- - ### Method Detail

    - #### newContext

          XPathContextMajor newContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context
      Returns:
        a new context, created as a copy of this context

    - #### newCleanContext

          XPathContextMajor newCleanContext()

      Construct a new context without copying (used for the context in a function call)
      Returns:
        a new clean context

    - #### newMinorContext

          XPathContextMinor newMinorContext()

      Construct a new minor context. A minor context can only hold new values of the focus (currentIterator) and current output destination.
      Returns:
        a new minor context

    - #### getLocalParameters

          ParameterSet getLocalParameters()

      Get the local (non-tunnel) parameters that were passed to the current function or template
      Returns:
        a ParameterSet containing the local parameters

    - #### getTunnelParameters

          ParameterSet getTunnelParameters()

      Get the tunnel parameters that were passed to the current function or template. This includes all active tunnel parameters whether the current template uses them or not.
      Returns:
        a ParameterSet containing the tunnel parameters

    - #### getController

          Controller getController()

      Get the Controller. May return null when running outside XSLT or XQuery
      Returns:
        the controller for this query or transformation

    - #### getConfiguration

          Configuration getConfiguration()

      Get the Configuration
      Returns:
        the Saxon configuration object

    - #### getNamePool

          NamePool getNamePool()

      Get the Name Pool
      Returns:
        the name pool

    - #### setCaller

          void setCaller​(XPathContext caller)

      Set the calling XPathContext
      Parameters:
        `caller` - the XPathContext of the calling expression

    - #### getCaller

          XPathContext getCaller()

      Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.
      Returns:
        the XPathContext of the calling expression

    - #### trackFocus

          FocusIterator trackFocus​(SequenceIterator iter)

      Create, set, and return a focus tracking iterator that wraps a supplied sequence iterator.
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### setCurrentIterator

          void setCurrentIterator​(FocusIterator iter)

      Set a new sequence iterator.
      Parameters:
        `iter` - the current iterator. The context item, position, and size are determined by reference to the current iterator.

    - #### getCurrentIterator

          FocusIterator getCurrentIterator()

      Get the current iterator. This encapsulates the context item, context position, and context size.
      Returns:
        the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

    - #### getContextItem

          Item getContextItem()

      Get the context item
      Returns:
        the context item, or null if the context item is undefined

    - #### getLast

          int getLast()
               throws XPathException

      Get the context size (the position of the last item in the current node list)
      Returns:
        the context size
      Throws:
        `XPathException` - if the context position is undefined

    - #### isAtLast

          boolean isAtLast()
                    throws XPathException

      Determine whether the context position is the same as the context size that is, whether position()=last(). In many cases this has better performance than a direct comparison, because it does not require reading to the end of the sequence.
      Returns:
        true if the context position is the same as the context size.
      Throws:
        `XPathException`

    - #### getURIResolver

          javax.xml.transform.URIResolver getURIResolver()

      Get the URI resolver. This gets the local URIResolver set in the XPathContext if there is one; if not, it gets the URIResolver from the Controller (which itself defaults to the one set in the Configuration).
      Returns:
        the user-supplied URI resolver if there is one, or null otherwise.
      Since:
        9.6

    - #### getErrorReporter

          ErrorReporter getErrorReporter()

      Get the error reporter. If no ErrorReporter has been set locally, the ErrorReporter in the Controller is returned; this in turn defaults to the ErrorReporter set in the Configuration.
      Returns:
        the ErrorReporter in use.
      Since:
        9.6. Changed in 10.0 from ErrorListener to ErrorReporter

    - #### getCurrentComponent

          Component getCurrentComponent()

      Get the current component

    - #### useLocalParameter

          int useLocalParameter​(StructuredQName parameterId,
                                int slotNumber,
                                boolean isTunnel)
                         throws XPathException

      Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated
      Parameters:
        `parameterId` - Globally-unique parameter identifier
        `slotNumber` - Slot number of the parameter within the stack frame of the called template
        `isTunnel` - True if a tunnel parameter is required, else false
      Returns:
        ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Throws:
        `XPathException`

    - #### getStackFrame

          StackFrame getStackFrame()

      Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.
      Returns:
        array of variables.

    - #### evaluateLocalVariable

          Sequence evaluateLocalVariable​(int slotnumber)

      Get the value of a local variable, identified by its slot number
      Parameters:
        `slotnumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
      Returns:
        the value of the variable.

    - #### setLocalVariable

          void setLocalVariable​(int slotNumber,
                                Sequence value)
                         throws XPathException

      Set the value of a local variable, identified by its slot number
      Parameters:
        `slotNumber` - the slot number allocated at compile time to the variable, which identifies its position within the local stack frame
        `value` - the value of the variable
      Throws:
        `XPathException`

    - #### setTemporaryOutputState

          void setTemporaryOutputState​(int temporary)

      Set the XSLT output state to "temporary" or "final"
      Parameters:
        `temporary` - set non-zero to set temporary output state; zero to set final output state

    - #### getTemporaryOutputState

          int getTemporaryOutputState()

      Ask whether the XSLT output state is "temporary" or "final"
      Returns:
        non-zero if in temporary output state (integer identifies the state); zero if in final output state

    - #### setCurrentOutputUri

          void setCurrentOutputUri​(java.lang.String uri)

      Set the current output URI
      Parameters:
        `uri` - the current output URI, or null if in temporary output state

    - #### getCurrentOutputUri

          java.lang.String getCurrentOutputUri()

      Get the current output URI
      Returns:
        the current output URI, or null if in temporary output state

    - #### getCurrentMode

          Component.M getCurrentMode()

      Get the current mode.
      Returns:
        the current mode

    - #### getCurrentTemplateRule

          Rule getCurrentTemplateRule()

      Get the current template rule. This is used to support xsl:apply-imports and xsl:next-match
      Returns:
        the current template rule

    - #### getCurrentGroupIterator

          GroupIterator getCurrentGroupIterator()

      Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0
      Returns:
        the current grouped collection

    - #### getCurrentMergeGroupIterator

          GroupIterator getCurrentMergeGroupIterator()

      Get the current merge group iterator. This supports the current-merge-group() and current-merge-key() functions in XSLT 2.0
      Returns:
        the current merge group

    - #### getCurrentRegexIterator

          RegexIterator getCurrentRegexIterator()

      Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.
      Returns:
        the current regular expressions iterator

    - #### getCurrentDateTime

          DateTimeValue getCurrentDateTime()
                                    throws NoDynamicContextException

      Get the current date and time
      Returns:
        the current date and time. All calls within a single query or transformation will return the same value
      Throws:
        `NoDynamicContextException`

    - #### getImplicitTimezone

          int getImplicitTimezone()

      Get the implicit timezone
      Returns:
        the implicit timezone. This will be the timezone of the current date and time, and all calls within a single query or transformation will return the same value. The result is expressed as an offset from UTC in minutes. If the implicit timezone is unknown (which is the case when this is called on an EarlyEvaluationContext), return `CalendarValue.NO_TIMEZONE`

    - #### iterateStackFrames

          java.util.Iterator iterateStackFrames()

      Get the context stack. This method returns an iterator whose items are instances of `ContextStackFrame`, starting with the top-most stackframe and ending at the point the query or transformation was invoked by a calling application.
      Returns:
        an iterator over a copy of the run-time call stack

    - #### getCurrentException

          XPathException getCurrentException()

      Get the current exception (in saxon:catch)
      Returns:
        the current exception, or null if there is none defined

    - #### getThreadManager

          XPathContextMajor.ThreadManager getThreadManager()

      Get the thread manager used to process asynchronous xsl:result-document threads.
      Returns:
        the current thread manager; or null if multithreading is not supported

    - #### waitForChildThreads

          void waitForChildThreads()
                            throws XPathException

      Wait for child threads started under the control of this context to finish. This is called at the end of the (main thread of a) transformation, and also at the end of the "try" part of a try/catch. The threads affected are those used to implement xsl:result-document instructions.
      Throws:
        `XPathException` - if any of the child threads have failed with a dynamic error.

    - #### getTargetComponent

          Component getTargetComponent​(int bindingSlot)

      Bind a component reference to a component. This is used for binding component references (such as function calls, global variable references, or xsl:call-template) across package boundaries. The binding is done dynamically because, in the presence of overridden components, the choice among different components with the same name depends on which package the caller is in.
      Parameters:
        `bindingSlot` - Binding slots are allocated statically to the external component references in every component: for example, in the case of a template, to all global variable references, named function calls, and named template calls within that template. The binding slot therefore identifies the name of the component that is required; and the selection of an actual component is done by selection from the binding vector of the component currently being executed
      Returns:
        the component to be invoked